



/**************************************************************/
/***********************INIZIO    DURATE.C*********************/
/**************************************************************/
/*--------------------------------------------------------------
	 Questo programma legge da tastiera una vocale, una consonan-
	 te e se le pronunce sono singole o geminate.
	 Quindi i file (creati da UNICE) VCV???.KEY o VCCV???.KEY ven-
	 gono aperti in lettura per calcolare poi le durate dei vari
	 segmenti temporali.
	 I file .KEY da leggere sono nel numero di NUM_PARLA*NUM_RIP.
	 Viene quindi creato un unico file di dati in formato testo
	 compatibile con EXCEL 97 di nome VCV.EXT_WRITE o
	 VCCV.EXT_WRITE che contiene le durate dei fonemi di tutti i
	 18 file aperti in precedenza.
*/

#include <stdio.h>
#include <stdlib.h>

#define NUM_PARLA    6       /* Deve essere un numero pari.  */
#define NUM_RIP      3
#define NUM_CAMPI_INIZIALI  3 /*Rappresenta il numero di parame-
										tri che vengono calcolati come differenza di
										due istanti di tempo letti dal file .EXTREAD
										e cioe' il numero di segmenti temporali che
										si interessa calcolare.                   */
#define NUM_NEWLINE_INIZIALI 4
#define EXT_READ   ".KEY\0"
#define EXT_WRITE  ".DUR\0"
#define FIRSTLINEKEY 8     /* La prima riga di dati da leggere
															 dei file .EXT_READ             */

int calcoladurate_e_appendi (char *,char *,short,short);

/*--------------------------------------------------------------
	Inizio del main program.
	Per il calcolo delle durate di ogni singolo file .EXT_READ e
	per la scrittura delle durate sul file .EXT_WRITE viene chia-
	mata la funzione calcoladurate_e_appendi.
*/
int main(void) /*Durate.c*/
{
	const char parla[NUM_PARLA][3]={"AV\0","EZ\0",
																	"GD\0","AI\0","MF\0","PM\0"};
	/* Nel caso di parlatori diversi occorre modificare le strin-
		 ghe costanti appena definite, lasciando nella prima meta'
		 della lista i parlatori femminili e nella seconda meta'
		 quelli maschili.                                         */
	const char extread[5]=EXT_READ,extdur[5]=EXT_WRITE;
	char  nomi_f[14],file_out[14];
	char  *pcons,*pvoc,*pgem;
	short shift=0,i,j,k;

	pcons=(char *)malloc(5*sizeof(char));
	pvoc =(char *)malloc(5*sizeof(char));
	pgem =(char *)malloc(5*sizeof(char));

	system("CLS");
	printf("\nCalcolo delle DURATE di segmenti di voce:");
	/* Vengono letti da tastiera vocale e consonante.           */
	printf("\n\nInserire vocale, consonante");
	printf(" e se geminata (s/n)\n");
	scanf ("%s%s%s",pvoc,pcons,pgem);











	/* Converte i caratteri letti in minuscolo.                 */
	if (*pcons<97) { *pcons+=32; *(pcons+1)+=32;}
	if (*pvoc<97)	 *pvoc+=32;
	if (*pgem<97)  *pgem+=32;

	/* Viene creata la parte dei nomi dei file che non
		 dipende dal parlatore.                                   */
	nomi_f[0]=file_out[0]=*pvoc;
	nomi_f[1]=file_out[1]=*pcons;
	if (*pgem=='s')
		{
			nomi_f[2]=file_out[2]=*pcons ;
			shift=1;
		}
	if (*pcons=='s' && *(pcons+1)=='c')       /* Caso della SC.*/
		 {
			 nomi_f[1]=file_out[1]='s';
			 nomi_f[2]=file_out[2]='c';
			 if (*pvoc=='a' || *pvoc=='u')
					{nomi_f[3]=file_out[3]='i';
					 shift=2;                  }
			 else shift=1;
		 }
	if (*pcons=='z')                          /* Caso della Z^.*/
		 {
			 nomi_f[1]=file_out[1]='z';
			 nomi_f[2]=file_out[2]='^';
			 shift=1;
		 }
	nomi_f[2+shift]=file_out[2+shift]=*pvoc;

	/* Viene aggiunta l'estensione ai nomi di file.             */
	for (k=0;k<=4;k++)
	{ nomi_f[6+k+shift]  =extread[k];
		file_out[3+k+shift]=extdur[k] ; }

	/* Ciclo che scandisce tutti i file .KEY al variare del
		 parlatore e del numero della ripetizione, calcola le du-
		 rate per ciascuno e le memorizza in un file VCV.EXT_WRITE*/
	for (i=0;i<=NUM_PARLA-1;i++)
	{
		 nomi_f[4+shift]=parla[i][0];
		 nomi_f[5+shift]=parla[i][1];

		 for (j=1;j<=NUM_RIP;j++)
				{
					 nomi_f[3+shift]=(char)j+48;
					 printf("\nLettura del file %s",nomi_f);

					 /* Il valore di ritorno -1 della funzione
							calcoladurate... segnala situazione di errore. 	*/
					 if (calcoladurate_e_appendi
									 (nomi_f,file_out,shift,i+j)==-1)
					 return (-1);
				}
	}
	printf("\nEsecuzione riuscita.\nFine.\n");
	return (0);
}














/*--------------------------------------------------------------
	 Funzione che:
	 1-riceve il puntatore sread alla stringa che contiene il
		 nome del file .KEY da leggere e il puntatore swrite
		 alla stringa col nome del file su cui scrivere;
		 riceve nella variabile passo il numero progressivo che
		 indica quale e' il file .KEY che si sta elaborando;
	 2-calcola le durate di v1, c, v2 e tot e le registra in un
		 file VCV.DUR (il nome e' la stringa puntata da swrite).
*/
int calcoladurate_e_appendi
		 (char *sread,char *swrite,short sh,short passo)
{
	unsigned int inizio_segmento,fine_segmento;
	float    durate[NUM_CAMPI_INIZIALI],durtot=0;
	FILE     *pfread;
	FILE     *pfwrite;
	short    line;

	/* Apre il file VCV???.KEY in lettura.                      */
	if ((pfread=fopen(sread,"r"))==NULL)
		 {
			printf ("\nFile %s non trovato\n",sread);
			return (-1);
		 }

	/* Salta le prime (FIRSTLINEKEY-1) righe non significative. */
	for (line=1;line<FIRSTLINEKEY;line++)
			while (fgetc(pfread)!='\n');

	/* Calcolo delle durate dei segmenti.                       */
	for (line=0;line<NUM_CAMPI_INIZIALI;line++)
		 {
			fscanf (pfread,"%u%u",&inizio_segmento,&fine_segmento);
			durate[line]=(fine_segmento-inizio_segmento)*0.1;
			durtot+=durate[line];
			while(fgetc(pfread)!='\n');
		 }
	/* In durate[0] e'memorizzata la durata del primo fonema di
		 interesse (in questo caso V1),e cosi' via.               */

	/* Registrazione delle durate nel file VCV.DUR.             */
	if (passo==1)
		{
		 if ((pfwrite=fopen(swrite,"w"))==NULL)
			 {	printf("\nErrore nella apertura del file .DUR");
					return (-1);																		}
		 else for(line=0;line<NUM_NEWLINE_INIZIALI;line++)
					 fputc('\n',pfwrite);
		}
	else if ((pfwrite=fopen(swrite,"a"))==NULL)
				 {	printf("\nErrore nella lettura del file .DUR");
						return (-1);																 	  }

	if (sh==2)   fprintf(pfwrite,"%.8s\t",sread);
		else if (sh==1) fprintf(pfwrite,"%.7s\t",sread);
			else          fprintf(pfwrite,"%.6s\t",sread);
	for (line=0;line<NUM_CAMPI_INIZIALI;line++)
			 fprintf (pfwrite,"%4.1f\t",durate[line]);
	fprintf (pfwrite,"%4.1f\t",durtot);
	/* Fin qui il numero di parametri calcolati e' 4            */

	/* Da questo punto inizia il calcolo di altri parametri oltre
		 alle durate semplici.                                    */









	/* Calcolo del rapporto tra le durate di C e di V1:
		 numero di parametri uguale a 5														*/
	fprintf (pfwrite,"%4.3f\t",(float)(durate[1]/durate[0]));
	/* Inserire in questo punto altri parametri che si vogliono
		 aggiungere in tutte le righe del file VCV.EXT_WRITE 	 	  */

	/* Chiusura dei file e terminazione del programma.          */
	fputc  ('\n',pfwrite);
	fclose (pfwrite);
	fclose (pfread);
	return (0);
}
/**************************************************************/
/***********************FINE     DURATE.C**********************/
/**************************************************************/
