



/**************************************************************/
/************************INIZIO   ENERGIE.C********************/
/**************************************************************/
/*--------------------------------------------------------------
	Programma che calcola energie e potenze di tutti i segnali di
	voce che si trovano nella directory corrente i cui campioni
	sono presi dal file .SIG (nel dominio del tempo) e .FFT (nel
	dominio della fequenza).
	La segmentazione della pronuncia e' letta dal file .KEY.
	La memorizzazione di tutti i parametri calcolati e la pronun-
	cia dal quale sono stati estratti avviene nell' unico file di
	output FILE_ENERGIE_OUT.
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <dir.h>
#include <dos.h>
#include <string.h>

#define NUM_SEGMENTI_FILEKEY 4
#define DELTA_F             39.0625
#define FREQUENZA_BASSA      0
#define FREQUENZA_ALTA     350
#define FILE_ENERGIE_OUT     "Energie.txt"
#define FILE_INPUT_SIG       "*.SIG\0"
#define EXT_FILE_INPUT_KEY   ".KEY\0"
#define EXT_FILE_INPUT_FFT   ".FFT\0"

short energia_potenza_neltempo (unsigned int, unsigned int,
					signed short *, unsigned short *, unsigned short *);
short energiaist_neltempo (unsigned int, signed short *,
					unsigned short *);
short energiaist_infrequenza (unsigned short, unsigned short,
					unsigned short, unsigned char *, double *, double *);


/*--------------------------------------------------------------
	Inizio del main program.
*/
short main (void)/*Energie.C*/
{
 const char frames=0,campioni=1,ext_key[]=EXT_FILE_INPUT_KEY,
						ext_fft[]=EXT_FILE_INPUT_FFT;
 typedef struct ffblk file_dos;

 file_dos *info;
 FILE *fsig,*fkey,*ffft,*fenergia;
 char nome_file_key[14],nome_file_fft[14];
 unsigned char c,*fftvett;
 signed short *signalvett;
 unsigned short ene_param1_db,ene_param2_db,ene_param3_db,
								pot_param1_db;
 unsigned int cont=0,i,j,num_frame=0,num_byte=0,num_campioni=0,
							segmenti_mat[2][NUM_SEGMENTI_FILEKEY][2];
 double ene_relativa,ene_1_frequenza_db,ene_2_frequenza_db;
 size_t pronuncia_len;


 system("CLS");
 if  ((fenergia=fopen(FILE_ENERGIE_OUT,"w"))==NULL)
			{printf("Errore nell'apertura del file energie.");
			 return (-1);																			}










 fputs ("NOME",fenergia);
 fputc ('\n',fenergia);
 fclose (fenergia);
 info = (file_dos *) malloc(sizeof(file_dos));

 if (findfirst(FILE_INPUT_SIG,info,FA_RDONLY))
			{printf ("Errore:non esistono file .sig");return (-1);}

 /* Ciclo che fa la scansione di tutta la directory corrente e
		fa una iterazione per ogni file x.SIG che trova.
		Nella directory devono esistere anche il corrispondente file
		x.KEY per conoscere la segmentazione della pronuncia e il
		file x.FFT per calcolare i parametri energetici nel dominio
		della frequenza.																          */
 do
 {
	 system("CLS");
	 cont += 1;

	 /*	Si memorizza il contenuto del file key in una matrice di
			unsigned int chiamata segmenti_mat.		                  */
	 pronuncia_len = strlen((*info).ff_name)-4;
	 for (i=0;i<pronuncia_len+1;i++)
			nome_file_key[i]=(*info).ff_name[i];
	 for (i=0;i<5;i++)
			nome_file_key[pronuncia_len+i]=ext_key[i];
	 if ((fkey=fopen (nome_file_key,"r"))==NULL)
			{	printf("Errore nell'apertura del file %s \n",
				nome_file_key);return(-1);										}
	 printf ("Lettura del file %s \t\tPRONUNCIA NUMERO: %d\n",
			nome_file_key,cont);
	 for (i=0;i<2;i++)
		 {
			 while (fgetc(fkey)!='\n');
			 for (j=0;j<NUM_SEGMENTI_FILEKEY;j++)
				 {
						fscanf(fkey,"%u%u",&segmenti_mat[i][j][0],
															 &segmenti_mat[i][j][1]);
						while (fgetc(fkey)!='\n');
						printf ("%u\t%u\n",segmenti_mat[i][j][0],
															 segmenti_mat[i][j][1]);
				 }
		 }
	 fclose (fkey);
	 printf ("Fatto.\n\n");


	 /* Si memorizzano in un vettore signalvett i campioni del
			segnale presi dal file .SIG (sono in 16 bit in complemento
			a due di cui il primo byte e' il meno significativo).	  */
	 num_byte  = (unsigned int) (*info).ff_fsize;
	 num_campioni = num_byte/2;
	 num_frame = num_campioni/128;

	 if ((signalvett=(signed short *)
						malloc (num_campioni * sizeof(signed short)))==NULL)
			{printf("Spazio esaurito in memoria per il segnale.");
			 return (-1);																					}
	 printf ("Lettura del file %s \n",(*info).ff_name);
	 if ((fsig=fopen((*info).ff_name,"rb"))==NULL)
			{printf("Errore nella apertura del file .sig\n");
			 return (-1);																					}











	 if (fread (signalvett,sizeof(signed short),num_campioni,fsig)
				!= num_campioni)
			{printf("Errore nella lettura del file .sig\n");
			 return (-1);																					}
	 fclose (fsig);
	 printf("Num. di frame: %d\tNum. di campioni: %d\t\nFatto.",
						num_frame,num_campioni);
	 printf("\n\n");


	 /*	SI CALCOLANO LE ENERGIE NEL DOMINIO DEL TEMPO.	        */
	 if ((fenergia=fopen(FILE_ENERGIE_OUT,"a"))==NULL)
			{printf("Errore nell'apertura del file Energie.txt");
			 return (-1);																					}
	 for (i=0; i<pronuncia_len ;i++)
			fputc((*info).ff_name[i],fenergia);
	 fputc ('\t',fenergia);
	 /* Energia totale e potenza della prima vocale.            */
	 if (energia_potenza_neltempo(segmenti_mat[campioni][1][0],
			 segmenti_mat[campioni][1][1],signalvett,&ene_param1_db,
			 &pot_param1_db))
			 printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%d\t%d\t",ene_param1_db,
								 pot_param1_db);
	 /* Energia totale e potenza della consonante.              */
	 if (energia_potenza_neltempo(segmenti_mat[campioni][2][0],
			 segmenti_mat[campioni][2][1],signalvett,&ene_param1_db,
			 &pot_param1_db))
			 printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%d\t%d\t",
								 ene_param1_db, pot_param1_db);
	 /* Energia istantanea al centro della prima vocale.        */
	 if (energiaist_neltempo((unsigned int)
			 ((segmenti_mat[campioni][1][0]+
				 segmenti_mat[campioni][1][1])/2),
			 signalvett,&ene_param1_db))
			 printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%d\t",ene_param1_db);
	 /* Energia istantanea alla transizione v1-c.               */
	 if (energiaist_neltempo(segmenti_mat[campioni][2][0],
			 signalvett,&ene_param2_db))
			 printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%d\t",ene_param2_db);
	 /* Energia istantanea al centro della consonante.          */
	 if (energiaist_neltempo((unsigned int)
			 ((segmenti_mat[campioni][2][0]+
				 segmenti_mat[campioni][2][1])/2),
			 signalvett,&ene_param3_db))
			 printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%d\t",ene_param3_db);
	 /* Energia istantanea all' offset di c.                    */
	 if (energiaist_neltempo((segmenti_mat[campioni][2][1]-128),
			 signalvett,&ene_param1_db))
			 printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%d\t",ene_param1_db);
	 /* Energia istantanea relativa vocale/consonante.          */
	 /*temp = (double)ene_param2_db - (double)ene_param1_db;
	 ene_relativa = pow(10,temp/10);
	 fprintf (fenergia,"%3.0f\t",ene_relativa);                 */

	 free (signalvett);












	 /* Si memorizzano i campioni della fft presi dal file .FFT
			nel vettore fftvett (sono in formato intero a 8 bit a 3/8
			di dB). 												                        */
	 for (i=0;i<pronuncia_len+1;i++)
			nome_file_fft[i]=(*info).ff_name[i];
	 for (i=0;i<5;i++)
			nome_file_fft[pronuncia_len+i]=ext_fft[i];
	 if ((ffft=fopen (nome_file_fft,"rb"))==NULL)
		 {printf("Errore nell'apertura del file %s \n",
			nome_file_fft);		return(-1);									}
	 printf ("Lettura del file %s \n",nome_file_fft);
	 if ((fftvett=(unsigned char *)
				malloc ((num_frame-1) * 128 * sizeof(unsigned char)))
				==	NULL)
		 {printf("Spazio insufficente in memoria.");return (-1);}
	 for (i=0; i<(num_frame-1) ;i++)
				{
					for (j=0;j<128;j++) fgetc(ffft);
					for (j=0;j<128;j++)
						 {
							 c = (unsigned char) fgetc(ffft);
							 fftvett[i*128+j] = c;
						 }
					for (j=0;j<128;j++) fgetc(ffft);
				}
	 fclose (ffft);
	 printf("Fatto.\n\n");


	 /* SI CALCOLANO LE ENERGIE NEL DOMINIO DELLA FREQUENZA.    */
	 /* Rapporto tra l' energia istantanea in banda 0-350 e totale
			0-5000 al centro della consonante in percentuale.       */
	 if (energiaist_infrequenza((unsigned short)
				((segmenti_mat[frames][2][0]+
					segmenti_mat[frames][2][1])/2),
					FREQUENZA_BASSA,FREQUENZA_ALTA,fftvett,
					&ene_1_frequenza_db,&ene_2_frequenza_db))
				printf ("Errore nella funzione chiamata.");
	 else fprintf (fenergia,"%2.2f\t",100*pow(10,
									(ene_1_frequenza_db-ene_2_frequenza_db)/10));

	 free (fftvett);

	 /*Terminazione della riga del file, chiusura del file stesso
		 e terminazione dell' iterazione del ciclo.		            */
	 fputc ('\n',fenergia);
	 fclose (fenergia);
	 if (div(cont,32).rem==0) system ("PAUSE");
 }
 while (findnext(info)==0); /* Fine del ciclo do-while.       */

 printf ("Fine dell'elaborazione.");
 return (0);
}/*Fine del main*/



















/*--------------------------------------------------------------
	Funzione che calcola l' energia e la potenza contenuta in una
	finestra temporale di (tf-ti) campioni.
	Per il calcolo eseguito nel dominio del tempo la funzione si
	serve del vettore di campioni del segnale il cui puntatore e'
	signal.
*/
short energia_potenza_neltempo (unsigned int ti,unsigned int tf,
					signed short *signal,unsigned short *energia_db,
					unsigned short *potenza_db)
{
	short i;
	double temp=0,energia=0;

	for (i=0; i+ti<tf ; i++)
			 {temp = (double)signal[i+ti]; energia += temp*temp;}
	*energia_db = (unsigned short)(10*log10(energia));
	*potenza_db = (unsigned short)(10*log10(energia/fabs(tf-ti)));

	return (0);
}



/*--------------------------------------------------------------
	Funzione che calcola l' energia contenuta in una finestra tem-
	porale di 256 campioni centrata sul campione t.
	Per il calcolo eseguito nel dominio del tempo la funzione si
	serve del vettore di campioni del segnale il cui puntatore e'
	signal.
*/
short energiaist_neltempo (unsigned int t,signed short *signal,
				 unsigned short *energia_db)
{
	short i;
	double temp=0,energia=0;

	for (i=0; i<256 ;i++)
		 {temp = (double)signal[i+t-128]; energia += temp*temp;}
	*energia_db = (unsigned short) (10*log10(energia));

	return (0);
}



/*--------------------------------------------------------------
	Funzione che calcola l' energia totale contenuta nel frame
	framenumber e quella contenuta nell' intervallo di frequenze
	f_low-f_high.
	Per il calcolo la funzione si serve del vettore di campioni
	FFT il cui puntatore e' transform.
*/
short energiaist_infrequenza
		 (unsigned short framenumber, unsigned short f_low,
			unsigned short f_high, unsigned char *transform,
			double *energiainbanda_db, double *energiatotale_db)
{
	unsigned short i;
	double campione,campione_db,energiainbanda=0,energiatotale=0;













	for (i=(unsigned short)(f_low/DELTA_F);
			 i<(unsigned short)(f_high/DELTA_F);i++)
			{
				campione_db=((double)transform[128*framenumber+i])*3/8;
				campione=pow(10,campione_db/10);
				energiainbanda += 2*campione*campione;
			}
	*energiainbanda_db=10*log10(energiainbanda);

	for (i=0;i<128;i++)
			{
				campione_db=((double)transform[128*framenumber+i])*3/8;
				campione=pow(10,campione_db/10);
				energiatotale += 2*campione*campione;
			}
	*energiatotale_db=10*log10(energiatotale);

	return (0);
}
/**************************************************************/
/**********************FINE    ENERGIE.C***********************/
/**************************************************************/
